SystemOrganization addCategory: #'FuelFameExtension-Tests'!
SystemOrganization addCategory: #'FuelFameExtension-Core'!
SystemOrganization addCategory: #'FuelFameExtension-Benchmarks'!
SystemOrganization addCategory: #'FuelFameExtension-Finder'!

FLSerializationTest subclass: #FLFameSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Tests'!

!FLFameSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/22/2010 10:31'!
isMerlinFamixAccess: anObject

	^ ((anObject class = FAMIXAccess and: 
		[ anObject variable name = #self ]) and: 
		[ anObject accessor name = #initialize]) and:
		[ anObject accessor parentType name = #ButtonPart ]! !

!FLFameSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/25/2010 18:43'!
isSampleFamixAccess: anObject

	^ ((anObject class = FAMIXAccess and: 
		[ anObject variable name = #self ]) and: 
		[ anObject accessor name = #hash ]) and:
		[ anObject accessor parentType name = #FLPair ]! !

!FLFameSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/18/2010 16:33'!
merlinMooseModel

	^ MooseSqueakClassPackageImporterTask new
		model: MooseModel new;
		addFromPackageNamed: #Merlin;
		run;
		model.
! !

!FLFameSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/17/2010 12:52'!
mooseMaterializationOn: aStream

	| tower |
	tower := FMCompleteTower new.
	tower metamodel addAll: MooseModel meta elements.
	FLFameObjectClusterSerializer instance repository: tower model.
	
	^ self materializationOn: aStream! !

!FLFameSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/24/2010 11:36'!
mooseSerializationOf: mooseModelEntities

	FLFameObjectClusterSerializer instance repository: 
		((FMRepository with: MooseModel meta) 
			addAll: mooseModelEntities;
			yourself).

	^ (self serializer 
		serialize: mooseModelEntities
		analyzer: FLFameAnalyzer newDefault) 
			stream
! !

!FLFameSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/25/2010 18:41'!
simpleMooseModel

	^ MooseSqueakClassPackageImporterTask new
		model: MooseModel new;
		addClass: FLPair;
		run;
		model.
! !

!FLFameSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/22/2010 10:32'!
testMerlinMooseModelEntities

	| stream original result |
	original := self merlinMooseModel entities.

	self assert: 1 equals: (original count: [ :anEntity | self isMerlinFamixAccess: anEntity ]). 

	stream := self mooseSerializationOf: original.
	result := self mooseMaterializationOn: stream reset.

	self assert: result notNil.
	self assert: original size equals: result size.
	self assert: 1 equals: (original count: [ :anEntity | self isMerlinFamixAccess: anEntity ]). 
	self assert: 1 equals: (result count: [ :anEntity | self isMerlinFamixAccess: anEntity ]).
! !

!FLFameSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/24/2010 10:50'!
testSimpleMooseModelEntities

	| stream original result |
	original := self simpleMooseModel entities.

	self assert: 2 equals: (original count: [ :anEntity | self isSampleFamixAccess: anEntity ]). 

	stream := self mooseSerializationOf: original.
	result := self mooseMaterializationOn: stream reset.

	self assert: result notNil.
	self assert: original size equals: result size.
	self assert: 2 equals: (original count: [ :anEntity | self isSampleFamixAccess: anEntity ]). 
	self assert: 2 equals: (result count: [ :anEntity | self isSampleFamixAccess: anEntity ]).
! !

!MooseModel classSide methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/24/2010 15:13'!
exportFL: aModel to: aStream
	self exportFL: aModel withMetamodel: self meta to: aStream! !

!MooseModel classSide methodsFor: '*FuelFameExtension' stamp: 'MartinDias 12/22/2010 13:28'!
exportFL: aModel withMetamodel: aMetamodel to: aStream 

	| bufferStream |
	bufferStream := ByteArray new writeStream.
	
	FLFameObjectClusterSerializer instance repository: 
		((FMRepository with: aMetamodel) 
			addAll: aModel entities;
			yourself).
	(FLSerializer on: bufferStream)
		serialize: aModel entities
		analyzer: FLFameAnalyzer newDefault.
		
	aStream binary nextPutAll: bufferStream contents.! !

!MooseModel classSide methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/24/2010 15:18'!
importFromFL: aStream

	^ self importFromFL: aStream withMetamodel: self meta! !

!MooseModel classSide methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/24/2010 15:18'!
importFromFL: aStream withMetamodel: aMetamodel

	| entities tower |
	tower := FMCompleteTower new.
	tower metamodel addAll: aMetamodel elements.
	FLFameObjectClusterSerializer instance repository: tower model.
	
	entities := (FLMaterializer on: aStream binary)
		materialize;
		root.

	tower model addAll: entities.
	tower model updateCache.
	^ tower model! !

!MooseModel methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/24/2010 15:11'!
exportToFL
	<menuItem: 'Export model to FL' category: 'Import / Export'>
	| stream |
	stream := UITheme builder 
		fileSave: 'Your title here'
		extensions: #('fl')
		path: nil.
	stream isNil ifFalse: [ 
		self exportToFLStream: stream.
		stream close.
		Notification signal: 'Save successful!!' ]! !

!MooseModel methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/24/2010 15:13'!
exportToFLStream: aStream 

	self class 
		exportFL: self
		to: aStream! !

!MooseModel methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/24/2010 15:21'!
importFromFL

	<menuItem: 'Import from FL' category: 'Import / Export'>
	| stream |	
	stream := UITheme builder
		fileOpen: 'Import model from Fuel file' 
		extensions: #('fl').
	stream isNil ifFalse: [
		self name: (FileDirectory baseNameFor: stream localName).
		self importFromFLStream: stream.
		stream close ]! !

!MooseModel methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/24/2010 15:21'!
importFromFLStream: aStream
	
	| repository |
	repository := self class importFromFL: aStream.
	repository elements do: [ :e | self add: e ].
	self entityStorage forRuntime! !

FLObjectAnalyzer subclass: #FLFameObjectAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Core'!

!FLFameObjectAnalyzer commentStamp: '<historical>' prior: 0!
I am an ObjectAnalyzer for objects whose class is described in Famix.

I work together with FLFameAnalyzer.!

!FLFameObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/17/2010 00:03'!
analyzes: anObject

	FLFameObjectClusterSerializer instance repository metamodel 
		descriptionOf: anObject class 
		ifAbsent: [ ^false ].
	^ true! !

!FLFameObjectAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 11/24/2010 11:30'!
value: anObject

	| serializer |
	self flag: #todo. "Improve this way of configuring the new cluster serializer!!"
	serializer := 
		(FLFameObjectClusterSerializer for: anObject class)
			repository: FLFameObjectClusterSerializer instance repository.	

	analyzer 
		clusters: analyzer clusteredFameObjects 
		add: anObject 
		serializer: serializer! !

!FLAnalyzer methodsFor: '*FuelFameExtension' stamp: 'MartinDias 11/22/2010 14:54'!
initializeWithFame

	self initializeDefaultAnalyzers.
	analyzers addFirst: (FLFameObjectAnalyzer newWith: self)! !

FLAnalyzer subclass: #FLFameAnalyzer
	instanceVariableNames: 'clusteredFameObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Core'!

!FLFameAnalyzer commentStamp: '<historical>' prior: 0!
I am an analyzer with a specific graph traversing behavior. 

Given an object described in a Fame repository, I work with its Famix metamodel description, for know which references traverse.!

!FLFameAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/23/2010 19:29'!
classDependenciesOf: aClass

	self flag: #todo. "access the repository in another way"

	^ ((((FLFameObjectClusterSerializer instance repository metamodel descriptionOf: aClass) allComplexAttributes)
		reject: [ :anAttribute | anAttribute isDerived ])
		collect: [ :anAttribute | anAttribute type implementingClass ]) asSet! !

!FLFameAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/23/2010 11:46'!
clusteredFameObjects
	
	^ clusteredFameObjects! !

!FLFameAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/23/2010 18:10'!
clusteredObjects
	"Returns a new collection with all the clustered objects, in Association instances."

	^ super clusteredObjects
		addAll: self sortedClusteredFameObjects;
		yourself.! !

!FLFameAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 11/24/2010 11:39'!
initialize

	super initialize.
	clusteredFameObjects := Dictionary new.! !

!FLFameAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 11/24/2010 11:34'!
initializeDefaultAnalyzers

	super initializeDefaultAnalyzers.
	analyzers addFirst: (FLFameObjectAnalyzer newWith: self)! !

!FLFameAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/24/2010 01:58'!
lessDependedOf: associations

	^ associations detect: [ :anAssoc | 
		associations allSatisfy: [ :anotherAssoc | 
			anAssoc == anotherAssoc or: [ 
				((self classDependenciesOf: anAssoc key clusteredClass) 
					anySatisfy: [ :aClass | anotherAssoc key clusteredClass isKindOf: aClass ]) not ] ] ]! !

!FLFameAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/24/2010 11:31'!
sortedClusteredFameObjects

	| sortedAssociations yetNotSortedAssociations |
	sortedAssociations := OrderedCollection new.
	yetNotSortedAssociations := clusteredFameObjects associations asOrderedCollection.

	[ yetNotSortedAssociations isEmpty ] whileFalse: [ 
		| next |
		next := self lessDependedOf: yetNotSortedAssociations..
		sortedAssociations add: next.
		yetNotSortedAssociations remove: next ].

	^ sortedAssociations! !

MPImportCommand subclass: #FLFameImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Finder'!

!FLFameImportCommand methodsFor: 'hooks' stamp: 'MartinDias 11/24/2010 15:24'!
execute
	| model |
	model := MooseModel new.
	model importFromFL.
	model size > 0 ifTrue: [
		model install.
		self addModel: model ]! !

!FLFameImportCommand methodsFor: 'hooks' stamp: 'MartinDias 11/24/2010 15:25'!
icon
	^ MenuIcons smallOpenIcon! !

!FLFameImportCommand methodsFor: 'hooks' stamp: 'MartinDias 11/24/2010 15:25'!
informationText
	^ 'Imports from a Fuel file.'! !

!FLFameImportCommand methodsFor: 'hooks' stamp: 'MartinDias 11/24/2010 15:25'!
label
	^ 'Import from FL'! !

TestCase subclass: #FLFameAnalyzerTest
	instanceVariableNames: 'analyzer repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Tests'!

!FLFameAnalyzerTest methodsFor: 'tests' stamp: 'MartinDias 11/24/2010 01:53'!
assert: aClass notDependsOn: yetNotVisitedClasses

	((repository metamodel descriptionOf: aClass) allComplexAttributes
		reject: [ :anAttribute | anAttribute isDerived ])
			do: [ :anAttribute | 
				self deny: (yetNotVisitedClasses anySatisfy: [ :aYetNotVisitedClass | 
					aYetNotVisitedClass isKindOf: anAttribute type implementingClass ]) ]! !

!FLFameAnalyzerTest methodsFor: 'running' stamp: 'MartinDias 11/22/2010 17:50'!
repositoryWithSample
	
	^ (FMRepository with: MooseModel meta) 
			addAll: self sampleMooseModel entities;
			yourself.! !

!FLFameAnalyzerTest methodsFor: 'running' stamp: 'MartinDias 11/24/2010 09:50'!
sampleMooseModel

	^ MooseModel lanSampleModel.
"	^ MooseSqueakClassPackageImporterTask new
		model: MooseModel new;
		addFromPackageNamed: #Merlin;
		run;
		model.
"! !

!FLFameAnalyzerTest methodsFor: 'running' stamp: 'MartinDias 11/24/2010 11:36'!
setUp

	super setUp.
	repository := self repositoryWithSample.
	FLFameObjectClusterSerializer instance repository: repository.
	analyzer := FLFameAnalyzer newDefault! !

!FLFameAnalyzerTest methodsFor: 'tests' stamp: 'MartinDias 11/24/2010 01:27'!
testClusteredObjectsOrder
	"The associations in clusteredObjects should be ordered ... (complete)"
	
	| yetNotVisitedClasses fameDescriptedClasses |
	analyzer analyze: self sampleMooseModel entities.

	fameDescriptedClasses := ((analyzer clusteredObjects 
		select: [ :anAssociation | 
			anAssociation key isKindOf: FLFameObjectClusterSerializer ]) 
		collect: [ :anAssociation | 
			anAssociation key clusteredClass ]).
	
	yetNotVisitedClasses := fameDescriptedClasses copy.
	
	fameDescriptedClasses
		do: [ :aClass | 
			yetNotVisitedClasses removeFirst.
			self assert: aClass notDependsOn: yetNotVisitedClasses]
 ! !

TestCase subclass: #FLFameObjectAnalyzerTest
	instanceVariableNames: 'mooseModel sampleDescription repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Tests'!

!FLFameObjectAnalyzerTest methodsFor: 'tests' stamp: 'MartinDias 11/25/2010 18:42'!
descriptionOfSampleIn: aRepository
		
	^ aRepository elements detect: [ :x | x class = FAMIXClass and: [ x name = #FLPair] ]! !

!FLFameObjectAnalyzerTest methodsFor: 'running' stamp: 'MartinDias 11/16/2010 23:53'!
repositoryWithSample
	
	^ (FMRepository with: MooseModel meta) 
			addAll: self sampleMooseModel entities;
			yourself.! !

!FLFameObjectAnalyzerTest methodsFor: 'tests' stamp: 'MartinDias 11/22/2010 14:54'!
sampleAnalyzer
	^ FLFameObjectAnalyzer newWith: nil! !

!FLFameObjectAnalyzerTest methodsFor: 'running' stamp: 'MartinDias 11/25/2010 18:41'!
sampleMooseModel

	^ MooseSqueakClassPackageImporterTask new
		model: MooseModel new;
		addClass: FLPair;
		run;
		model.
! !

!FLFameObjectAnalyzerTest methodsFor: 'running' stamp: 'MartinDias 11/17/2010 01:37'!
setUp

	super setUp.
	repository := self repositoryWithSample.
	FLFameObjectClusterSerializer instance repository: repository.
	sampleDescription := self descriptionOfSampleIn: repository.
! !

!FLFameObjectAnalyzerTest methodsFor: 'tests' stamp: 'MartinDias 11/17/2010 00:41'!
testAnalyzes

	self
		assert: (self sampleAnalyzer analyzes: sampleDescription)
		description: 'It should accept analyzing an object whose class is described in the repository'! !

!FLFameObjectAnalyzerTest methodsFor: 'tests' stamp: 'MartinDias 11/17/2010 00:42'!
testDoesNotAnalyze

	self 
		deny: (self sampleAnalyzer analyzes: 42) 
		description: 'It should not accept analyzing an object whose class is not described in the repository'! !

!FLFameObjectAnalyzerTest methodsFor: 'tests' stamp: 'MartinDias 11/17/2010 12:46'!
testValue

"	This needs Mocketry, but it has conflicts with Moose.

	[ :analyzerMock |
		[ (FLFameAnalyzer newWith: analyzerMock) value: sampleDescription ] 
			should strictly satisfy:  
				[ analyzerMock 	
					clusteredBaselevelObjects;
					clusters: Any add: Any serializer: Any ].
	] runScenario"! !

FLClusterSerializer subclass: #FLFameObjectClusterSerializer
	instanceVariableNames: 'repository clusteredClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Core'!

!FLFameObjectClusterSerializer commentStamp: '<historical>' prior: 0!
I serialize and materialize objects using its Famix meta description. 

At the moment, the metamodel should be the same when serializing and materializing, or incongruences could appear.!

!FLFameObjectClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 11/17/2010 01:01'!
for: aClass

	^ self basicNew
		clusteredClass: aClass;
		yourself.! !

!FLFameObjectClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/16/2010 16:12'!
id

	^ 82! !

!FLFameObjectClusterSerializer methodsFor: 'comparing' stamp: 'MartinDias 11/17/2010 01:02'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self clusteredClass = anObject clusteredClass! !

!FLFameObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 11/17/2010 01:03'!
clusteredClass
	^ clusteredClass! !

!FLFameObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 11/17/2010 01:03'!
clusteredClass: anObject
	clusteredClass := anObject! !

!FLFameObjectClusterSerializer methodsFor: 'comparing' stamp: 'MartinDias 11/17/2010 01:02'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self clusteredClass hash! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/24/2010 16:41'!
materializeAllWith: aMaterializer

	| class instanceCount clusterInstances classDescription attributes primitiveAttributes nonPrimitiveAttributes |
	class := aMaterializer nextReferencedObject.
	instanceCount := aMaterializer nextInteger.

	classDescription := repository metamodel descriptionOf: class.
	clusterInstances := OrderedCollection new: instanceCount.
	instanceCount timesRepeat: [ clusterInstances add: classDescription createInstance ].

	attributes := classDescription allAttributes reject: [ :anAttribute | anAttribute isDerived ].
"	primitiveAttributes := attributes select: [ :anAttribute | anAttribute type isPrimitive ].
	nonPrimitiveAttributes := attributes select: [ :anAttribute | anAttribute type isPrimitive not ].
"
 	aMaterializer 
		addAllMaterialized: clusterInstances;
		referenceMaterializingActionsAdd:
			[ self 
				materializeAttributes: attributes
				ofAll: clusterInstances 
				with: aMaterializer 
				classDescription: classDescription ]
"		referenceMaterializingActionsAdd:
			[ self 
				materializeAttributes: primitiveAttributes
				ofAll: clusterInstances 
				with: aMaterializer 
				classDescription: classDescription ];
		postReferenceMaterializingActionsAdd:
			[ self 
				materializeAttributes: nonPrimitiveAttributes
				ofAll: clusterInstances 
				with: aMaterializer 
				classDescription: classDescription ]"! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/27/2010 15:23'!
materializeAttribute: anInstance of: anAttribute with: aMaterializer

	| valuesSize values |
	valuesSize := aMaterializer nextInteger.

	self flag: #todo. "Encoding for skip ignored values (see #serializeIgnoredValueWith:)"
	(valuesSize = 0) 
		ifTrue: [ ^ self ].

	values := Array new: valuesSize.
	1 to: valuesSize do: [ :index | 
		values at: index put: aMaterializer nextReferencedObject ].	
		
	anAttribute 
		setOn: anInstance 
		values: values! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/22/2010 11:08'!
materializeAttributes: attributes ofAll: instances with: aMaterializer classDescription: aClassDescription

	instances do: [ :anInstance |
		attributes do: [ :anAttribute |
			self 
				materializeAttribute: anInstance 
				of: anAttribute 
				with: aMaterializer ] ]! !

!FLFameObjectClusterSerializer methodsFor: 'printing' stamp: 'MartinDias 11/17/2010 15:30'!
printOn: aStream

	super printOn: aStream.
	aStream 
		nextPutAll: ' (';
		nextPutAll: clusteredClass fullName;
		nextPutAll: ')'.! !

!FLFameObjectClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/24/2010 14:37'!
referencesOf: anObject do: aBlock

	| description |
	aBlock value: anObject class.

	((repository metaDescriptionOf: anObject) 
		allAttributes reject: [ :anAttribute | anAttribute isDerived ]) 
			do: [ :anAttribute |
				(repository 
					get: anAttribute
					element: anObject) 
						do: [ :aValue |
							aBlock value: aValue ] ]! !

!FLFameObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 11/16/2010 23:43'!
repository
	^ repository! !

!FLFameObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 11/16/2010 23:43'!
repository: anObject
	repository := anObject! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/24/2010 16:42'!
serializeAll: clusterInstances with: aSerializer

	| attributes primitiveAttributes nonPrimitiveAttributes |
	attributes := (repository metamodel descriptionOf: clusteredClass) allAttributes reject: [ :anAttribute | anAttribute isDerived ].
"	primitiveAttributes := attributes select: [ :anAttribute | anAttribute type isPrimitive ].
	nonPrimitiveAttributes := attributes select: [ :anAttribute | anAttribute type isPrimitive not ]."
	
	aSerializer 
		nextPutReferenceTo: clusteredClass;
		nextPutInteger: clusterInstances size;
		referenceSerializingActionsAdd:
			[ self serializeAttributes: attributes ofAll: clusterInstances with: aSerializer ]
"		referenceSerializingActionsAdd:
			[ self serializeAttributes: primitiveAttributes ofAll: clusterInstances with: aSerializer ];
		postReferenceSerializingActionsAdd:
			[ self serializeAttributes: nonPrimitiveAttributes ofAll: clusterInstances with: aSerializer ]"! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/24/2010 10:24'!
serializeAttribute: anAttribute values: values with: aSerializer

	(self shouldIgnore: anAttribute withAll: values)
		ifTrue: [ self serializeIgnoredValueWith: aSerializer ]
		ifFalse: [ self serializeValues: values with: aSerializer ]
! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/22/2010 10:59'!
serializeAttributes: attributes ofAll: instances with: aSerializer

	instances do: [ :anInstance |
		attributes do: [ :anAttribute |
			self 
				serializeAttribute: anAttribute 
				values: (repository get: anAttribute element: anInstance) 
				with: aSerializer ] ].! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/27/2010 15:22'!
serializeIgnoredValueWith: aSerializer

	self flag: #todo. "Encode in another way that its an ignored value."
	aSerializer nextPutInteger: 0! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/17/2010 11:38'!
serializeValues: values with: aSerializer

	aSerializer nextPutInteger: values size.
	values do: [ :aValue | aSerializer nextPutReferenceTo: aValue ]! !

!FLFameObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/24/2010 10:22'!
shouldIgnore: attribute withAll: values
	"Copied from FMRepositoryVisitor>>ignoreProperty:withAll:"

	^ values isEmpty or: [
		attribute isDerived or: [
			attribute type == FM3MetaDescription boolean and: [
				values size == 1 and: [ 
					values first == false ]]]]! !

Object subclass: #FLFameBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelFameExtension-Benchmarks'!

!FLFameBenchmarks commentStamp: '<historical>' prior: 0!
I implement benchmarks for comparing Fuel and MSE exporting and importing Moose models. 

To tun, first install the model and then run the benchmarks. The results are shown in Transcript. 

[MooseScripts createLightModelForNetwork] timeToRun." 3334"
FLFameBenchmarks new runWithInstalledModelNamed: 'lightNetwork'.

[MooseScripts createLightModelForMorphic] timeToRun." 3730"
FLFameBenchmarks new runWithInstalledModelNamed: 'lightMorphic'.

[MooseScripts createModelForNetwork] timeToRun." 3999"
FLFameBenchmarks new runWithInstalledModelNamed: 'Network'.

[MooseScripts createModelForMorphic] timeToRun." 16193"
FLFameBenchmarks new runWithInstalledModelNamed: 'Morphic'.

[MooseScripts createLightModelForPharo] timeToRun. " 25617"
FLFameBenchmarks new runWithInstalledModelNamed: 'lightPharo'.

[MooseScripts createModelForMoose] timeToRun." 31207"
FLFameBenchmarks new runWithInstalledModelNamed: 'Moose'.

"Toooo huge"
[MooseScripts createModelForPharo] timeToRun." 1014041"
FLFameBenchmarks new runWithInstalledModelNamed: 'Pharo'.

!

!FLFameBenchmarks classSide methodsFor: 'obsolete' stamp: 'MartinDias 11/24/2010 16:17'!
exportingScripts

| modelName model |

MoosePanel open.
MooseModel resetRoot.

MooseModel lanSampleModel install.
MooseScripts createLightModelForPharo. 
MooseScripts createModelForNetwork.

modelName := 'MerlinMooseModel'.
modelName := 'CompilerMooseModel'.
modelName := 'lightPharo'.
modelName := 'lanSampleModel'.
modelName := 'Network'.


model := MooseModel root entityStorage detect: [:each | each name = modelName ].


Smalltalk garbageCollect.
[ model exportToFLStream: (FileStream forceNewFileNamed: modelName, '.fuel2') ] timeToRun.   
"Compiler:
 20941
 18931
 22741
Merlin:
 5648
 5696
 4965
 7146
Lan:
 758
LightPharo:
 224104
Network:
 25619
"

Smalltalk garbageCollect.
[ model exportToFuelStream: (FileStream forceNewFileNamed: modelName, '.fuel') ] timeToRun.  
"Compiler: 
 96967
 91816
Lan:
 1451
"

Smalltalk garbageCollect.
[ model exportToMSEStream: (FileStream forceNewFileNamed: modelName, '.mse') ] timeToRun.  
"Compiler: 
 37867
 35946
 36580
Merlin:
 9151
Lan:
 910
LightPharo:
 330779
Network:
 45302
"
! !

!FLFameBenchmarks classSide methodsFor: 'obsolete' stamp: 'MartinDias 11/24/2010 16:16'!
importingScripts

| modelName |

modelName := 'MerlinMooseModel'.
modelName := 'CompilerMooseModel'.
modelName := 'lightPharo'.
modelName := 'lanSampleModel'.
modelName := 'Network'.


Smalltalk garbageCollect.
[ MooseModel new
	name: modelName, 'Fuel2';
	importFromFLStream: (FileStream fileNamed: modelName, '.fuel2');
	install.
] timeToRun.  
"Compiler:
 4093
 5923
 4479
Merlin:
 1434
Lan:
 151
LightPharo:
 95555
Network:
 4605
"

Smalltalk garbageCollect.
[ MooseModel new
	name: modelName, 'Fuel';
	importFromFuelStream: (FileStream fileNamed: modelName, '.fuel');
	install.
] timeToRun.  
"Compiler: 
 12704
 21642
Lan:
 360
"


Smalltalk garbageCollect.
[ MooseModel new
	name: modelName, 'Mse';
	importFromMSEStream: (FileStream fileNamed: modelName, '.mse');
	install.
] timeToRun. 
"Compiler: 
 29796
 20498
 28742
Merlin:
 5284
Lan:
 534
LightPharo:
Network:
 38595
"

! !

!FLFameBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/27/2010 15:21'!
addFileSizeOf: aStream titled: aTitle

	Transcript 
		nextPutAll: aTitle;
		nextPutAll: ' file size: ';
		nextPutAll: aStream contents byteSize asBytesDescription;
		nextPutAll: ' bytes';
		cr;
		flush.! !

!FLFameBenchmarks methodsFor: 'testing' stamp: 'MartinDias 11/24/2010 16:19'!
addResultRunning: aBlock titled: aTitle

	Smalltalk garbageCollect.

	Transcript 
		nextPutAll: aTitle;
		nextPutAll: ': ';
		nextPutAll: aBlock timeToRun printString;
		nextPutAll: ' ms';
		cr;
		flush.! !

!FLFameBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/27/2010 16:11'!
benchSelectors

	^ #(runMSEWith: runFLWith:)! !

!FLFameBenchmarks methodsFor: 'testing' stamp: 'MartinDias 11/26/2010 11:21'!
newStreamNamed: aFileName

	^ FileStream forceNewFileNamed: aFileName! !

!FLFameBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/22/2010 16:14'!
runFLWith: aModel

	| aStream |

	aStream := (self newStreamNamed: aModel name, '.fl').
	self addResultRunning: [ aModel exportToFLStream: aStream ] titled: 'FL export'.

	aStream reset.
	self addResultRunning: [ MooseModel new importFromFLStream: aStream ] titled: 'FL import'.

	self addFileSizeOf: aStream titled: 'FL'
! !

!FLFameBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/22/2010 16:14'!
runMSEWith: aModel

	| aStream |

	aStream := (self newStreamNamed: aModel name, '.mse').
	self addResultRunning: [ aModel exportToMSEStream: aStream ] titled: 'MSE export'.

	aStream reset.
	self addResultRunning: [ MooseModel new importFromMSEStream: aStream ] titled: 'MSE import'.

	self addFileSizeOf: aStream titled: 'MSE'
! !

!FLFameBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/27/2010 12:16'!
runWithInstalledModelNamed: aName

	| aModel |
	aModel := MooseModel root entityStorage detect: [:each | each name = aName ].

	Transcript show: 'Benchmarks for model named: ', aName; cr.
	
	self benchSelectors do: [ :aBenchmarkSelector |
		self perform: aBenchmarkSelector with: aModel.
	] displayingProgress: 'Running benchmarks'! !
